package cn.ibizlab.r7.runtime.service.runtimemgr.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.core.r7rt_base.valuerule.anno.userroledataaction.*;
import cn.ibizlab.r7.runtime.core.r7rt_base.domain.UserRoleDataAction;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[UserRoleDataActionDTO]
 */
public class UserRoleDataActionDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [USERROLEDATAACTIONID]
     *
     */
    @UserRoleDataActionUserRoleDataActionIdDefault(info = "默认规则")
    private String userRoleDataActionId;

    @JsonIgnore
    private boolean userRoleDataActionIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @UserRoleDataActionUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @UserRoleDataActionCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @UserRoleDataActionUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [USERROLEDATAACTIONNAME]
     *
     */
    @UserRoleDataActionUserRoleDataActionNameDefault(info = "默认规则")
    private String userRoleDataActionName;

    @JsonIgnore
    private boolean userRoleDataActionNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @UserRoleDataActionCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [ENABLE]
     *
     */
    @UserRoleDataActionEnableDefault(info = "默认规则")
    private Integer enable;

    @JsonIgnore
    private boolean enableDirtyFlag;

    /**
     * 属性 [USERROLEDATANAME]
     *
     */
    @UserRoleDataActionUserRoleDataNameDefault(info = "默认规则")
    private String userRoleDataName;

    @JsonIgnore
    private boolean userRoleDataNameDirtyFlag;

    /**
     * 属性 [USERROLEDATAID]
     *
     */
    @UserRoleDataActionUserRoleDataIdDefault(info = "默认规则")
    private String userRoleDataId;

    @JsonIgnore
    private boolean userRoleDataIdDirtyFlag;


    /**
     * 获取 [USERROLEDATAACTIONID]
     */
    @JsonProperty("userroledataactionid")
    public String getUserRoleDataActionId(){
        return userRoleDataActionId ;
    }

    /**
     * 设置 [USERROLEDATAACTIONID]
     */
    @JsonProperty("userroledataactionid")
    public void setUserRoleDataActionId(String  userRoleDataActionId){
        this.userRoleDataActionId = userRoleDataActionId ;
        this.userRoleDataActionIdDirtyFlag = true ;
    }

    /**
     * 获取 [USERROLEDATAACTIONID]脏标记
     */
    @JsonIgnore
    public boolean getUserRoleDataActionIdDirtyFlag(){
        return userRoleDataActionIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [USERROLEDATAACTIONNAME]
     */
    @JsonProperty("userroledataactionname")
    public String getUserRoleDataActionName(){
        return userRoleDataActionName ;
    }

    /**
     * 设置 [USERROLEDATAACTIONNAME]
     */
    @JsonProperty("userroledataactionname")
    public void setUserRoleDataActionName(String  userRoleDataActionName){
        this.userRoleDataActionName = userRoleDataActionName ;
        this.userRoleDataActionNameDirtyFlag = true ;
    }

    /**
     * 获取 [USERROLEDATAACTIONNAME]脏标记
     */
    @JsonIgnore
    public boolean getUserRoleDataActionNameDirtyFlag(){
        return userRoleDataActionNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [ENABLE]
     */
    @JsonProperty("enable")
    public Integer getEnable(){
        return enable ;
    }

    /**
     * 设置 [ENABLE]
     */
    @JsonProperty("enable")
    public void setEnable(Integer  enable){
        this.enable = enable ;
        this.enableDirtyFlag = true ;
    }

    /**
     * 获取 [ENABLE]脏标记
     */
    @JsonIgnore
    public boolean getEnableDirtyFlag(){
        return enableDirtyFlag ;
    }

    /**
     * 获取 [USERROLEDATANAME]
     */
    @JsonProperty("userroledataname")
    public String getUserRoleDataName(){
        return userRoleDataName ;
    }

    /**
     * 设置 [USERROLEDATANAME]
     */
    @JsonProperty("userroledataname")
    public void setUserRoleDataName(String  userRoleDataName){
        this.userRoleDataName = userRoleDataName ;
        this.userRoleDataNameDirtyFlag = true ;
    }

    /**
     * 获取 [USERROLEDATANAME]脏标记
     */
    @JsonIgnore
    public boolean getUserRoleDataNameDirtyFlag(){
        return userRoleDataNameDirtyFlag ;
    }

    /**
     * 获取 [USERROLEDATAID]
     */
    @JsonProperty("userroledataid")
    public String getUserRoleDataId(){
        return userRoleDataId ;
    }

    /**
     * 设置 [USERROLEDATAID]
     */
    @JsonProperty("userroledataid")
    public void setUserRoleDataId(String  userRoleDataId){
        this.userRoleDataId = userRoleDataId ;
        this.userRoleDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [USERROLEDATAID]脏标记
     */
    @JsonIgnore
    public boolean getUserRoleDataIdDirtyFlag(){
        return userRoleDataIdDirtyFlag ;
    }



    public UserRoleDataAction toDO() {
        UserRoleDataAction srfdomain = new UserRoleDataAction();
        if(getUserRoleDataActionIdDirtyFlag())
            srfdomain.setUserRoleDataActionId(userRoleDataActionId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUserRoleDataActionNameDirtyFlag())
            srfdomain.setUserRoleDataActionName(userRoleDataActionName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getEnableDirtyFlag())
            srfdomain.setEnable(enable);
        if(getUserRoleDataNameDirtyFlag())
            srfdomain.setUserRoleDataName(userRoleDataName);
        if(getUserRoleDataIdDirtyFlag())
            srfdomain.setUserRoleDataId(userRoleDataId);

        return srfdomain;
    }

    public void fromDO(UserRoleDataAction srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUserRoleDataActionIdDirtyFlag())
            this.setUserRoleDataActionId(srfdomain.getUserRoleDataActionId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUserRoleDataActionNameDirtyFlag())
            this.setUserRoleDataActionName(srfdomain.getUserRoleDataActionName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getEnableDirtyFlag())
            this.setEnable(srfdomain.getEnable());
        if(srfdomain.getUserRoleDataNameDirtyFlag())
            this.setUserRoleDataName(srfdomain.getUserRoleDataName());
        if(srfdomain.getUserRoleDataIdDirtyFlag())
            this.setUserRoleDataId(srfdomain.getUserRoleDataId());

    }

    public List<UserRoleDataActionDTO> fromDOPage(List<UserRoleDataAction> poPage)   {
        if(poPage == null)
            return null;
        List<UserRoleDataActionDTO> dtos=new ArrayList<UserRoleDataActionDTO>();
        for(UserRoleDataAction domain : poPage) {
            UserRoleDataActionDTO dto = new UserRoleDataActionDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

